﻿using Styx;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.Linq;
using System.Threading.Tasks;

#region Redundancy
using HK = DemoLock.Managers.Hotkeys;
using S = DemoLock.Core.Spell;
using SB = DemoLock.Helpers.SpellBook;
using U = DemoLock.Core.Unit;
using L = DemoLock.Helpers.Log;
#endregion

namespace DemoLock.Rotation
{
    class Combat
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }


        //Combat Buffing
        public static async Task<bool> combatBuffing()
        {
            if (HK.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            if (!Me.Pet.IsAutoAttacking && !Me.Mounted && U.isUnitValid(currentTarget, 43)) { Lua.DoString("PetAttack()"); }
            if (await S.Buff(SB.summonFelguard, (Me.Pet.IsDead || !Me.GotAlivePet) && S.lastSpellCast != SB.summonFelguard)) return true;
            return await S.Cast(0, true);
        }

        //Rotation
        public static async Task<bool> rotationSelector()
        {
            if (HK.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            else if (U.activeEnemies(Me.Pet.Location, 8f).Count() > 1 && await AoE()) return true;
 
            return await singleTarget();
        }

        //AoE
        public static async Task<bool> AoE()
        {
            //Doom if Moving & No Doom
            if (await S.Cast(SB.doom, !U.auraExists(currentTarget, SB.doom))) return true;
            //Shadow flame,if=debuff.shadowflame.stack>0&remains<action.shadow_bolt.cast_time+travel_time
            if (await S.Cast(SB.shadowFlame, U.isUnitValid(currentTarget, 43) && !currentTarget.HasAura(SB.shadowFlame))) return true;
            //summon_doomguard,if=talent.grimoire_of_synergy.enabled&spell_targets.infernal_awakening<3
            if (await S.Cast(SB.summonDoomguard, HK.cooldownsOn && U.isUnitValid(currentTarget, 43))) return true;
            //call_dreadstalkers,if=!talent.summon_darkglare.enabled&(spell_targets.implosion<3|!talent.implosion.enabled)
            if (await S.Cast(SB.callDreadStalkers, U.isUnitValid(currentTarget, 43))) return true;
            //Hand of Gul'dan if Sould Shard >= 4 and Darkglare is not enabled
            if (await S.Cast(SB.handOfGuldan, Me.CurrentSoulShards >= 4 && U.isUnitValid(currentTarget, 43) || Me.CurrentSoulShards >= 3 && S.lastSpellCast == SB.callDreadStalkers)) return true;
            //Demonic Empowerment if last spell was hand of guldan or if wild imp has no demonic empowerment
            if (await S.Buff(SB.demonicEmpowerment, S.lastSpellCast != SB.demonicEmpowerment && (S.lastSpellCast == SB.handOfGuldan || S.lastSpellCast == SB.callDreadStalkers || (U.wildImpCount >= 5 && U.wildImpWithDemEmpCount < U.wildImpCount)))) return true;
            //Felguard:Felstorm
            if (await S.Cast(SB.commandDemon, Me.Pet.IsWithinMeleeRangeOf(currentTarget))) return true;
            //Shadowflame if charges = 2
            if (await S.Cast(SB.shadowFlame, S.GetCharges("Shadow Flame") == 2 && U.isUnitValid(currentTarget, 43))) return true;
            //Thal'kiels Consumption if=(dreadstalker_remaining_duration>execute_time|talent.implosion.enabled&spell_targets.implosion>=3)&wild_imp_count>3&wild_imp_remaining_duration>execute_time
            if (await S.Cast(SB.thalkielsConsumption, U.useArtifact && U.isUnitValid(currentTarget, 43))) return true;
            //Life Tap if mana < 30% or moving
            if (await S.Buff(SB.lifeTap, Me.IsMoving && Me.ManaPercent < 60 || Me.ManaPercent <= 30)) return true;
            //Demonwrath
            return await S.Cast(SB.demonWrath, !Me.Mounted && U.doomTimeLeft > 500 && U.isUnitValid(currentTarget, 43));
        }

        //Single Target
        public static async Task<bool> singleTarget()
        {

            //Doom if Moving & No Doom
            if (await S.Cast(SB.doom, !U.auraExists(currentTarget, SB.doom))) return true;
            //Shadow flame,if=debuff.shadowflame.stack>0&remains<action.shadow_bolt.cast_time+travel_time
            if (await S.Cast(SB.shadowFlame, U.isUnitValid(currentTarget, 43) && !currentTarget.HasAura(SB.shadowFlame))) return true;
            //summon_doomguard,if=talent.grimoire_of_synergy.enabled&spell_targets.infernal_awakening<3
            if (await S.Cast(SB.summonDoomguard, HK.cooldownsOn && U.isUnitValid(currentTarget, 43))) return true;
            //call_dreadstalkers,if=!talent.summon_darkglare.enabled&(spell_targets.implosion<3|!talent.implosion.enabled)
            if (await S.Cast(SB.callDreadStalkers, U.isUnitValid(currentTarget, 43))) return true;
            //Hand of Gul'dan if Sould Shard >= 4 and Darkglare is not enabled
            if (await S.Cast(SB.handOfGuldan, Me.CurrentSoulShards >= 4 && U.isUnitValid(currentTarget, 43) || Me.CurrentSoulShards >= 3 && S.lastSpellCast == SB.callDreadStalkers)) return true;
            //Demonic Empowerment if last spell was hand of guldan or if wild imp has no demonic empowerment
            if (await S.Buff(SB.demonicEmpowerment, S.lastSpellCast != SB.demonicEmpowerment && (S.lastSpellCast == SB.handOfGuldan || S.lastSpellCast == SB.callDreadStalkers || (U.wildImpCount >= 5 && U.wildImpWithDemEmpCount < U.wildImpCount)))) return true;
            //Felguard:Felstorm
            if (await S.Cast(SB.commandDemon, Me.Pet.IsWithinMeleeRangeOf(currentTarget))) return true;
            //Shadowflame if charges = 2
            if (await S.Cast(SB.shadowFlame, S.GetCharges("Shadow Flame") == 2 && U.isUnitValid(currentTarget, 43))) return true;
            //Thal'kiels Consumption if=(dreadstalker_remaining_duration>execute_time|talent.implosion.enabled&spell_targets.implosion>=3)&wild_imp_count>3&wild_imp_remaining_duration>execute_time
            if (await S.Cast(SB.thalkielsConsumption, U.useArtifact && U.isUnitValid(currentTarget, 43))) return true;
            //Life Tap if mana < 30% or moving
            if (await S.Buff(SB.lifeTap, Me.IsMoving && Me.ManaPercent < 60 || Me.ManaPercent <= 30)) return true;
            //Demonbolt
            return await S.Cast(SB.demonBolt, U.isUnitValid(currentTarget, 43));
        }

    }
}

/*
A	0.00	demonbolt,if=talent.demonbolt.enabled
B	0.00	shadow_bolt,if=!talent.demonbolt.enabled
C	21.10	shadowflame,if=debuff.shadowflame.stack>0&remains<action.shadow_bolt.cast_time+travel_time
D	3.00	summon_doomguard,if=talent.grimoire_of_synergy.enabled&spell_targets.infernal_awakening<3
E	25.18	call_dreadstalkers,if=!talent.summon_darkglare.enabled&(spell_targets.implosion<3|!talent.implosion.enabled)
F	42.24	hand_of_guldan,if=soul_shard>=4&!talent.summon_darkglare.enabled
G	3.08	hand_of_guldan,if=soul_shard>=3&prev_gcd.call_dreadstalkers
H	45.23	demonic_empowerment,if=wild_imp_no_de>3|prev_gcd.hand_of_guldan
I	22.91	demonic_empowerment,if=dreadstalker_no_de>0|darkglare_no_de>0|doomguard_no_de>0|infernal_no_de>0|service_no_de>0
J	1.10	felguard:felstorm
K	2.95	berserking(Racial)
L	1.00	potion,name=deadly_grace,if=buff.soul_harvest.remains|target.time_to_die<=45|trinket.proc.any.react
M	10.84	shadowflame,if=charges=2
N	9.11	thalkiels_consumption,if=(dreadstalker_remaining_duration>execute_time|talent.implosion.enabled&spell_targets.implosion>=3)&wild_imp_count>3&wild_imp_remaining_duration>execute_time
O	16.29	life_tap,if=mana.pct<=30
P	160.12	demonbolt
*/
